<!DOCTYPE html>
<html>
<head lang="en">
	<meta charset="utf-8">
	<title>Etoiles</title>
	<style>
        body {
            margin: 1px auto;
            width: 500px;
            background: black;
            border: solid 1px darkgray;
           
        }
	</style>
</head>
<body>
    <script type="text/javascript" src="js/data.js"></script>
    <script type="text/javascript" src="js/algebre.js"></script>
    <script type="module">
        import * as THREE from "./utils/three.module.min.js";

        /* 0. définitions des constantes et variables globales */
        // les positions et tailles des planetes seront assez éloignées de la réalité, mais
        // on peut les nommer dans l'ordre mercure, venus, terre, mars, jupiter, saturne, uranus, neptune
        const couleurs = [0x666666, 0xff7f00, 0x0080ff, 0x800000, 0x00cc99, 0x004455, 0xffbb44, 0xff00aa];
        const planetOdg = [30, 15, 20, 15, 70, 60, 40, 40];
        let animateState = true;
        let sceneHalfWidth = 3000;
        let sprites = [], sprite;
        sprites.push(new THREE.TextureLoader().load('./textures/snowflake1.png'));
        sprites.push(new THREE.TextureLoader().load('./textures/snowflake2.png'));
        sprites.push(new THREE.TextureLoader().load('./textures/snowflake3.png'));
        sprites.push(new THREE.TextureLoader().load('./textures/snowflake4.png'));
        sprites.push(new THREE.TextureLoader().load('./textures/snowflake5.png'));

        /* 1. création d'une scène et d'un renderer*/
        const scene = new THREE.Scene();

        const renderer = new THREE.WebGLRenderer({ antialias: true, preserveDrawingBuffer: true });
        renderer.setSize(500, 500);
        document.body.appendChild(renderer.domElement);

        
        /* 2. create Camera - > OrthographicCamera(left : Number, right : Number, top : Number, bottom : Number, near : Number, far : Number)*/       
        let camera = new THREE.OrthographicCamera(-sceneHalfWidth, sceneHalfWidth, sceneHalfWidth, -sceneHalfWidth, 0, 2 * sceneHalfWidth);
        camera.position.set(0, 0, 3000);
        camera.lookAt(0, 0, 0);

       
        /* 3. create 3D objets */
    
        //i = 1,2,ou 3
        //top = taille de la flèche,
        //ahw = arrow half width,
        //ab = arrow bottom
        function createArrow(color = 0xaa3333, i = 1, top = 500, ab = 250, ahw = 150) {
    const material = new THREE.LineBasicMaterial({ color: color });

    const points = [];
    const coords = [
        [0, 0, 0],
        [top, 0, 0],
        [ab, ahw, 0],
        [top, 0, 0],
        [ab, -ahw, 0]
    ];
    coords.forEach(t => points.push(new THREE.Vector3(t[0], t[1], t[2])));
    const geometry = new THREE.BufferGeometry().setFromPoints(points);
    const line = new THREE.Line(geometry, material);

    switch (i) {
        case 1: // i (Rouge) - Pas de rotation nécessaire
            break;
        case 2: // j (Vert) - Rotation autour de l'axe z
            line.rotation.z = Math.PI / 2;
            break;
        case 3: // k (Bleu) - Rotation autour de l'axe y
            line.rotation.y = -Math.PI / 2;
            break;
    }

    return line;
}







        function createOneSetOfStars(vertices, sprite) {
            let geometry = new THREE.BufferGeometry();
            let time = Math.pow(Date.now() * 0.0005, 2);
            let h = (360 * (1.0 + time) % 360) / 360;
            let starMaterial = new THREE.PointsMaterial({ size: 17, map: sprite, alphaTest: 0.5, transparent: true });
            starMaterial.color.setHSL(h, 0.5, 0.5, THREE.SRGBColorSpace);
            sprite.colorSpace = THREE.SRGBColorSpace;
            geometry.setAttribute('position', new THREE.Float32BufferAttribute(vertices, 3));
            let stars = new THREE.Points(geometry, starMaterial);
            stars.position.z=-3400;
            return stars;
        }

        function addAllStars(scene, vertices, sprite) {
            const nv = vertices.length;
            let k = Math.floor(nv / (3 * sprites.length));
            //console.log("nombre d'étoiles", nv/3, ", nombre de textures ", sprites.length );

            let i, tmp;
            for (i = 0; (i + 1) * k * 3 < nv; i++) {
                if (i < sprites.length) sprite = sprites[i];
                tmp = vertices.slice(i * k * 3, (i + 1) * k * 3);
                scene.add(createOneSetOfStars(tmp, sprite));
                //console.log(i, ' ', k, ' ', i * k, ' ', tmp);
            }
        }

        function createRepere() {
    // Créer un groupe pour les vecteurs
    let group = new THREE.Group();

    // Créer les vecteurs avec la fonction createArrow
    let vectorI = createArrow(0xff0000); // Rouge pour i
    let vectorJ = createArrow(0x00ff00, 2); // Vert pour j
    let vectorK = createArrow(0x0000ff, 3); // Bleu pour k

    // Ajouter les vecteurs au groupe
    group.add(vectorI);
    group.add(vectorJ);
    group.add(vectorK);

    // Retourner le groupe
    return group;
}

function createSphere(color, radius) {
    const geometry = new THREE.SphereGeometry(radius, 32, 32); // 32 segments pour une sphère lisse
    const material = new THREE.MeshBasicMaterial({ color: color });
    const sphere = new THREE.Mesh(geometry, material);
    return sphere;
}


        /* 4. create listener to handle user input*/
        document.body.addEventListener('pointerdown', onPointerDown);
        function onPointerDown(event) {
            animateState = !animateState;
            animate();
        }

        document.body.addEventListener('keydown', onKeyDown);
        let x = 0, y = 0, z = 0;
        let dx = 0, dy = 0, dz = 0, epsilon = Math.PI / 10;

        function onKeyDown(e) {
    e.preventDefault();

    switch (e.keyCode) {
        case 37: //left
            if (e.ctrlKey) {
                repere.rotation.z -= Math.PI / 10; // Rotation anti-horaire autour de k
            } else {
                repere.rotation.y += Math.PI / 10; // Rotation horaire autour de j
            }
            break;
        case 39: //right
            if (e.ctrlKey) {
                repere.rotation.z += Math.PI / 10; // Rotation horaire autour de k
            } else {
                repere.rotation.y -= Math.PI / 10; // Rotation anti-horaire autour de j
            }
            break;
        case 38: //up
            repere.rotation.x += Math.PI / 10; // Rotation horaire autour de i
            break;
        case 40: //down
            repere.rotation.x -= Math.PI / 10; // Rotation anti-horaire autour de i
            break;
        case 90: //z
            repere.rotation.set(0, 0, 0); // Remise à zéro
            break;
    }

    renderer.render(scene, camera); // Rendu après la rotation
}

        /* 5. programme init and main loop */
        let frameNum = 0;
        addAllStars(scene, vertices, sprites);
       
        let repere = createRepere();
scene.add(repere);
// Rotation de PI/10 autour du vecteur i
//repere.rotation.x = Math.PI / 10;

// Rotation de 2PI/10 autour du vecteur j
//repere.rotation.y = 2 * Math.PI / 10;

// Rotation de 3PI/10 autour du vecteur k
//repere.rotation.z = 3 * Math.PI / 10;

// Rotation de -PI/10 autour du vecteur i
//repere.rotation.x -= Math.PI / 10;
camera.position.set(1000, 1000, 3000);
camera.lookAt(0, 0, 0);
const sun = createSphere(0xffff00, 100); // couleur jaune et rayon de 100 pour le soleil
scene.add(sun);

const rayons = [30, 15, 15, 10, 70, 60, 40, 40];


let distanceFromSun = 150 + rayons[0]; // distance initiale du soleil
let planets = [];

for (let i = 0; i < rayons.length; i++) {
    const planet = createSphere(couleurs[i], rayons[i]);
    planet.position.x = distanceFromSun;

    // Définir le centre de rotation (le soleil dans ce cas)
    const centerOfRotation = new THREE.Vector3(0, 0, 0);

    // Calculer la position relative de la planète par rapport au centre de rotation
    const relativePosition = planet.position.clone().sub(centerOfRotation);

    // Appliquer la rotation affine
    relativePosition.applyAxisAngle(new THREE.Vector3(0, 1, 0), i * Math.PI / 8);

    // Mettre à jour la position de la planète
    planet.position.addVectors(centerOfRotation, relativePosition);
    planets.push(planet);

    scene.add(planet);
    if (i < rayons.length - 1) {
        distanceFromSun += rayons[i] + rayons[i + 1] + 80;
    }
}

const spaceshipRadius = 20; // Réglez la taille du vaisseau spatial selon vos besoins
const spaceshipTube = 10; // Réglez la taille du tube du vaisseau spatial selon vos besoins
const spaceshipGeometry = new THREE.TorusGeometry(spaceshipRadius, spaceshipTube, 16, 100);
const spaceshipMaterial = new THREE.MeshBasicMaterial({ color: 0xffffff }); // Réglez la couleur du vaisseau spatial selon vos besoins
const spaceship = new THREE.Mesh(spaceshipGeometry, spaceshipMaterial);

// Positionnez le vaisseau spatial initialement à (0, 0, 0) ou à la position souhaitée
spaceship.position.set(0, 0, 0);

// Ajoutez le vaisseau spatial en tant qu'enfant du repère
repere.add(spaceship);
repere.position.set(0, 1000, 0);


function animate() {
   if (animateState) {
        requestAnimationFrame(animate);

        // Générez des valeurs aléatoires pour le déplacement du vaisseau spatial
        const dx = (Math.random() - 0.5) * 10; // Ajustez la plage et la vitesse de déplacement selon vos besoins
        const dy = (Math.random() - 0.5) * 10; // Ajustez la plage et la vitesse de déplacement selon vos besoins
        const dz = (Math.random() - 0.5) * 10; // Ajustez la plage et la vitesse de déplacement selon vos besoins

        // Appliquez le déplacement au vaisseau spatial
        spaceship.position.x += dx;
        spaceship.position.y += dy;
        spaceship.position.z += dz;

        // Assurez-vous que le vaisseau spatial reste dans les limites de la scène
        const bounds = sceneHalfWidth - spaceshipRadius;
        if (Math.abs(spaceship.position.x) > bounds ||
            Math.abs(spaceship.position.y) > bounds ||
            Math.abs(spaceship.position.z) > bounds) {
            // Le vaisseau spatial est hors des limites, réinitialisez sa position
            spaceship.position.set(0, 0, 0);
        }
    }


    // Mettre à jour la position de chaque planète
    for (let i = 0; i < planets.length; i++) {
        const planet = planets[i];

        // Définir le centre de rotation (le soleil dans ce cas)
        const centerOfRotation = new THREE.Vector3(0, 0, 0);

        // Calculer la position relative de la planète par rapport au centre de rotation
        const relativePosition = planet.position.clone().sub(centerOfRotation);

        // Appliquer la rotation affine
        relativePosition.applyAxisAngle(new THREE.Vector3(0, 1, 0), i * Math.PI / 8 / 60); // Diviser par 60 pour ralentir la rotation

        // Mettre à jour la position de la planète
        planet.position.addVectors(centerOfRotation, relativePosition);
    }

    renderer.render(scene, camera);
}

        animate();
    </script>
</body>
</html>
